
/*
	|----
		-Author: Outlawled
		-Created: 7 March 2013
		-Updated: 7 October 2013
		-Version: 3.0.2 (Script)
		-Description:	- Allows the player to repack the ammo in his magazines.
						- Default keybinding to open the Mag Repack dialog is "Left Ctrl+R", this can be customized via the options menu in the Mag Repack dialog.
						- Pressing "Alt+Shift+Ctrl+Backspace" will reset the keybinding to the default setting (in case the player forgets what he changed his keybinding to).
						- The player may choose a magazine from a list of all of his magazines to be the "Source" magazine and then he may choose a magazine
						from a list of all of his magazines of the same ammo type as the Source magazine to be the "Target" magazine (or vice versa). As soon
						as the Source and Target are both defined, bullets from the Source magazine will automatically start repacking into the	Target magazine.
	|----
*/


outlw_MR_bulletTime = 5; // Seconds per individual bullet.
outlw_MR_beltTime = 3; // Seconds per belt magazine.


////////////////////////////////////////////////////////////////////////////////////////////////////

if (isClass(configFile >> "CfgPatches" >> "outlw_magRepack")) exitWith {};

disableSerialization;

outlw_MR_canCreateDialog = true;
outlw_MR_keybindingMenuActive = false;
outlw_MR_debugMode = profileNamespace getVariable ["outlw_MR_debugMode_profile", false];
outlw_MR_doHideFull = profileNamespace getVariable ["outlw_MR_doHideFull_profile", false];
outlw_MR_keyList = profileNamespace getVariable ["outlw_MR_keyList_profile", [29,19]];

outlw_MR_pressedKeys = [];
outlw_MR_keysHeld = false;
outlw_KB_current = [];

outlw_MR_convertableList = (getArray(configfile >> "CfgWeapons" >> "arifle_MX_F" >> "GL_3GL_F" >> "Magazines"));

[] execVM "tmf\support\modules\outlw_magrepack\Scripts\MagRepack_Main.sqf";
[] execVM "tmf\support\modules\outlw_magrepack\Scripts\MagRepack_Keybindings.sqf";
[] execVM "tmf\support\modules\outlw_magrepack\Scripts\MagRepack_Misc.sqf";

waitUntil {!(isNil "outlw_MR_getIDCs")};

outlw_MR_listIDCs = [(missionConfigFile >> "MR_Dialog" >> "Controls")] call outlw_MR_getIDCs;
outlw_MR_listMoveableIDCs = [(missionConfigFile >> "MR_Dialog" >> "Controls"), {getNumber(_config >> _ctrl >> "moving") == 1}] call outlw_MR_getIDCs;

waitUntil {!(isNull (findDisplay 46))};

(findDisplay 46) displayAddEventHandler ["KeyDown", "_this call outlw_MR_keyDown;"];
(findDisplay 46) displayAddEventHandler ["KeyUp", "_this call outlw_MR_keyUp;"];

systemChat "Mag Repack Initialized";
systemChat ("Keybinding: " + ([outlw_MR_keyList, "'"] call outlw_MR_keyCodeToString));